=== debian/changelog ===
rr (5.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Refer to the common-licenses CC0 copy in debian/copyright.
  * Switch to debhelper compatibility level 11.
  * Standards-Version 4.1.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 08 Jan 2018 11:51:50 +0100

rr (5.0.0-1) unstable; urgency=medium

  * New upstream release:
    - merge gcc-7.patch;
    - add build-dependencies for Cap'n Proto;
    - document new third-party code;
    - drop documentation, no longer shipped;
    - enable PIE.
  * Standards-Version 4.1.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 08 Sep 2017 19:13:07 +0200
