=== debian/control ===
Source: rr
Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: capnproto,
               cmake,
               debhelper (>= 11~),
               g++-multilib,
               gdb,
               libcapnp-dev,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python,
               python-pexpect
# The following are required for the test suite
# realpath
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
Homepage: http://rr-project.org

Package: rr
Architecture: amd64 i386
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel CPUs with Nehalem or later microarchitectures.
