=== debian/changelog ===
rr (5.2.0-5ubuntu1) eoan; urgency=medium

  * Fix build with new glibc (tgkill prototype mismatch)
  * Workaround sysctl missing on new glibc with Wno-implicit-function-declaration

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 19:22:07 +0200

rr (5.2.0-5) unstable; urgency=medium

  * Apply upstream patches to switch to Python 3. Closes: #938413.
  * Switch to debhelper compatibility level 12.
  * Standards-Version 4.4.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 31 Aug 2019 15:17:20 +0200

rr (5.2.0-4) unstable; urgency=medium

  * Build only on amd64, since the i386 package isn’t aligned with the
    i386 “baseline”. Closes: #915337.
  * Switch to C++14 for C++ code, as required by capnproto 0.7.
  * Standards-Version 4.3.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 02 Jan 2019 12:02:08 +0100

rr (5.2.0-3) unstable; urgency=medium

  * Apply upstream patch to drop ucontext_t, which broke with glibc 2.28.
    Closes: #915338.
  * Standards-Version 4.2.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Dec 2018 08:51:54 +0100

rr (5.2.0-2) unstable; urgency=medium

  * Stop stripping librrpreload, its debug symbols are needed at runtime.
  * Set “Rules-Requires-Root: no”.
  * Standards-Version 4.2.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 17 Aug 2018 09:32:06 +0200

rr (5.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 29 May 2018 22:36:22 +0200

rr (5.1.0-2) unstable; urgency=medium

  * Migrate to Salsa.
  * Update debian/copyright.
  * Standards-Version 4.1.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 15 May 2018 21:00:13 +0200
