=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,11 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+export DEB_CFLAGS_MAINT_APPEND = -Wno-implicit-function-declaration
 export DH_OPTIONS += -O-Bbuild
+
+%:
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_test:
 # Tests are disabled since they only work on supported CPUs
@@ -17,5 +21,8 @@
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
-%:
-	dh $@ --buildsystem=cmake
+override_dh_strip:
+	dh_strip -Xlibrrpreload
+
+override_dh_dwz:
+	dh_dwz --no-dwz-multifile
