## rr 5.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # *-* Mode: cmake; *-*
 
-cmake_minimum_required(VERSION 2.8.5)
+cmake_minimum_required(VERSION 3.1.0)
 project(rr C CXX ASM)
 
 # "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
@@ -33,27 +33,59 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 2)
+set(rr_VERSION_MINOR 3)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
-set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread -g3")
+execute_process(
+  COMMAND git rev-parse HEAD
+  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+  OUTPUT_VARIABLE GIT_REVISION
+  OUTPUT_STRIP_TRAILING_WHITESPACE
+)
+configure_file(
+  ${CMAKE_SOURCE_DIR}/src/git_revision.h.in
+  ${CMAKE_BINARY_DIR}/git_revision.h
+)
+
+set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
-set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
-
-set(RR_FLAGS_DEBUG "-Wall -Wextra -Werror -O0 -DDEBUG -UNDEBUG")
-set(RR_FLAGS_RELEASE "-Wall -Wextra -O2 -UDEBUG -DNDEBUG")
-set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG}")
-
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+
+# We support three build types:
+# DEBUG: suitable for debugging rr
+# RELEASE: suitable for using rr in production (but keeps rr debuginfo)
+# OTHER: suitable for using rr in production, but honouring distro/user opt/debug settings
+# (which we assume are suitable for production use)
+
+# Base settings for debug and release/unspecified builds.
+# Use -Werror for debug builds because we assume a developer is building, not a user.
+set(RR_FLAGS_DEBUG "-Wall -Wextra -DDEBUG -UNDEBUG")
+set(RR_FLAGS_RELEASE "-Wall -Wextra -UDEBUG -DNDEBUG")
+
+# The folowing settings are the defaults for the OTHER build type.
+# Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3")
+# Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
+set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
+# Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
+set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG} -g3 -O0")
+# Flags used to build other files. Entirely build-type-dependent.
+set(RR_FLAGS ${RR_FLAGS_RELEASE})
+
+# Now override for build type.
 string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_CMAKE_BUILD_TYPE)
 if(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "debug")
-  set(RR_FLAGS ${RR_FLAGS_DEBUG})
-else()
-  set(RR_FLAGS ${RR_FLAGS_RELEASE})
+  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} -O2 -Werror")
+  set(BROTLI_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -O2")
+  set(RR_TEST_FLAGS "${RR_TEST_FLAGS} -Werror")
+  set(RR_FLAGS "${RR_FLAGS_DEBUG} -g3 -Werror")
+elseif(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "release")
+  # CMake itself will add optimization flags
+  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3")
 endif()
 
 if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -61,6 +93,9 @@
 endif()
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
+endif()
+if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang")
+  set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
 
 option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
@@ -149,6 +184,7 @@
 # ==== brotli ====
 set(BROTLI_FILES
   third-party/brotli/common/dictionary.c
+  third-party/brotli/common/transform.c
   third-party/brotli/dec/bit_reader.c
   third-party/brotli/dec/decode.c
   third-party/brotli/dec/huffman.c
@@ -179,6 +215,7 @@
   third-party/brotli/enc/dictionary_hash.c
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
+  third-party/brotli/enc/encoder_dict.c
   third-party/brotli/enc/entropy_encode.c
   third-party/brotli/enc/entropy_encode.h
   third-party/brotli/enc/entropy_encode_static.h
@@ -213,7 +250,7 @@
 )
 add_library(brotli STATIC ${BROTLI_FILES})
 set_source_files_properties(${BROTLI_FILES}
-                            PROPERTIES COMPILE_FLAGS ${RR_FLAGS_RELEASE})
+                            PROPERTIES COMPILE_FLAGS ${BROTLI_COMPILE_FLAGS})
 # ==== brotli ====
 
 find_path(SECCOMP NAMES "linux/seccomp.h")
@@ -221,11 +258,8 @@
   message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
 endif()
 
-# Check for Python >=2.7 but not Python 3.
-find_package(PythonInterp 2.7 REQUIRED)
-if(PYTHON_VERSION_MAJOR GREATER 2)
-  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
-endif()
+set(Python_ADDITIONAL_VERSIONS 3 3.8 3.7 3.6 3.5 3.4 3.3 3.2 3.1 3.0)
+find_package(PythonInterp 3 REQUIRED)
 
 execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "# nothing"
                 RESULT_VARIABLE python_status)
@@ -263,18 +297,6 @@
   endif()
 endif()
 
-set(PRELOAD_COMPILE_FLAGS "-fno-stack-protector")
-
-if (DEBUG_PRELOAD_LIB)
-  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_DEBUG}")
-else()
-  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_RELEASE}")
-endif()
-
-set_source_files_properties(src/preload/syscallbuf.c
-                            src/preload/overrides.c
-                            PROPERTIES COMPILE_FLAGS ${PRELOAD_COMPILE_FLAGS})
-
 include_directories("${PROJECT_SOURCE_DIR}/include")
 include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
 include_directories("${PROJECT_SOURCE_DIR}/third-party/brotli/include")
@@ -283,40 +305,12 @@
 
 # Order matters here! syscall_hook.S must be immediately before syscallbuf.c,
 # breakpoint_table.S must be before overrides.c, which must be last.
-add_library(rrpreload
-  src/preload/syscall_hook.S
-  src/preload/syscallbuf.c
-  src/preload/raw_syscall.S
-  src/preload/breakpoint_table.S
-  src/preload/overrides.c
-)
-set_target_properties(rrpreload PROPERTIES LINK_FLAGS "-nostartfiles")
-
-# Ensure that CMake knows about our generated files.
-#
-# Alphabetical, please.
-set(GENERATED_FILES
-  AssemblyTemplates.generated
-  CheckSyscallNumbers.generated
-  SyscallEnumsX64.generated
-  SyscallEnumsX86.generated
-  SyscallEnumsForTestsX64.generated
-  SyscallEnumsForTestsX86.generated
-  SyscallHelperFunctions.generated
-  SyscallnameArch.generated
-  SyscallRecordCase.generated
-)
-
-foreach(generated_file ${GENERATED_FILES})
-  set_source_files_properties(${generated_file}
-                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
-  add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
-                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
-		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
-		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
-		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
-		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
-endforeach(generated_file)
-
-add_custom_target(Generated DEPENDS ${GENERATED_FILES})
-
+set(PRELOAD_FILES
+  syscall_hook.S
+  syscallbuf.c
+  raw_syscall.S
+  breakpoint_table.S
+  overrides.c
+)
+set(PRELOAD_SOURCE_FILES
+  ${PRELOAD_FILES}
