=== debian/changelog ===
rr (5.3.0-2) unstable; urgency=medium

  * Move the preload libraries back to /usr/lib/rr, with no multiarch
    subdirectories, so that rr can find them again. Thanks to Michael
    Weghorn for the patch! Closes: #951325.
  * Standards-Version 4.5.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 15 Feb 2020 11:48:21 +0100

rr (5.3.0-1) unstable; urgency=medium

  * New upstream release, merging most of the patches in this package.
  * Standards-Version 4.4.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 18 Dec 2019 18:54:01 +0100
