=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 12),
+               dh-python,
                g++-multilib,
                gdb,
                libcapnp-dev,
@@ -15,7 +16,7 @@
                python3-pexpect
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: http://rr-project.org
@@ -24,6 +25,7 @@
 Package: rr
 Architecture: amd64
 Depends: ${misc:Depends},
+         ${python3:Depends},
          ${shlibs:Depends}
 Description: application execution recorder, player and debugger
  rr allows application executions to be recorded and then replayed
