=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DH_OPTIONS += -O-Bbuild

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --with=python3

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel CPUs from Nehalem onwards)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
	mkdir -p debian/rr/usr/lib/rr
	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/librrpreload* debian/rr/usr/lib/rr/
	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
	chmod 644 debian/rr/usr/share/bash-completion/completions/rr

override_dh_strip:
	dh_strip -Xlibrrpreload

override_dh_dwz:
	dh_dwz --no-dwz-multifile

override_dh_python3:
	dh_python3 --no-ext-rename
