## rr 5.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,12 +28,13 @@
 
 set(BUILD_TESTS ON CACHE BOOL "Build tests")
 set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
+option(INSTALL_TESTSUITE "Install the testsuite")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 3)
+set(rr_VERSION_MINOR 4)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
@@ -49,11 +50,27 @@
   ${CMAKE_BINARY_DIR}/git_revision.h
 )
 
-set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread")
+set(FLAGS_COMMON "-D__USE_LARGEFILE64 -pthread")
+set(supports32bit true)
+set(x86ish false)
+if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
+  set(supports32bit false)
+  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a")
+else()
+  set(x86ish true)
+  set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
+endif()
+
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+include(CheckCXXCompilerFlag)
+CHECK_CXX_COMPILER_FLAG("-std=c++14" SUPPORTS_CXX14)
+if (SUPPORTS_CXX14)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+else()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
+endif()
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -68,7 +85,7 @@
 
 # The folowing settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
-set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3")
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
 set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
 # Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
@@ -85,7 +102,14 @@
   set(RR_FLAGS "${RR_FLAGS_DEBUG} -g3 -Werror")
 elseif(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "release")
   # CMake itself will add optimization flags
-  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3")
+  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3 -flto")
+endif()
+
+set(LINKER_FLAGS "")
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  # Gcc generates bogus R_386_GOTOFF relocations in .debug_info which
+  # lld 9 rejects
+  set(LINKER_FLAGS "-fuse-ld=bfd")
 endif()
 
 if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -107,7 +131,7 @@
   set(rr_MBITNESS_OPTION -m32)
 else()
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
-    if(disable32bit)
+    if(disable32bit OR NOT supports32bit)
       set(rr_32BIT false)
     else()
       set(rr_32BIT true)
@@ -291,26 +315,3 @@
 
 if(WILL_RUN_TESTS)
   # Check for gdb
-  execute_process(COMMAND "gdb" "--version" RESULT_VARIABLE module_status OUTPUT_QUIET)
-  if(module_status)
-    message(FATAL_ERROR "Couldn't find gdb.")
-  endif()
-endif()
-
-include_directories("${PROJECT_SOURCE_DIR}/include")
-include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
-include_directories("${PROJECT_SOURCE_DIR}/third-party/brotli/include")
-# We need to know where our generated files are.
-include_directories("${CMAKE_CURRENT_BINARY_DIR}")
-
-# Order matters here! syscall_hook.S must be immediately before syscallbuf.c,
-# breakpoint_table.S must be before overrides.c, which must be last.
-set(PRELOAD_FILES
-  syscall_hook.S
-  syscallbuf.c
-  raw_syscall.S
-  breakpoint_table.S
-  overrides.c
-)
-set(PRELOAD_SOURCE_FILES
-  ${PRELOAD_FILES}
