=== debian/changelog ===
rr (5.4.0-2) unstable; urgency=medium

  * Update upstream references to github.com/rr-debugger instead of
    github.com/mozilla.

 -- Stephen Kitt <skitt@debian.org>  Wed, 06 Jan 2021 08:26:47 +0100

rr (5.4.0-1) unstable; urgency=medium

  * Source-only upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Nov 2020 21:17:17 +0100

rr (5.4.0-1~exp1) experimental; urgency=medium

  * New upstream release, restoring i386 support and introducing support
    for some Zen CPUs and some AArch64 platforms.
    Closes: #961710, #961926.
  * Switch to debhelper compatibility level 13.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Nov 2020 18:12:33 +0100

rr (5.3.0-4) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Stephen Kitt ]
  * Apply upstream patches to support new vDSO syscalls. Closes:
    #968686.
  * The current release doesn’t work on i386 (see #961926), drop that
    architecture until the next release.
  * Allow building with g++-i686-linux-gnu as well as g++-multilib.

 -- Stephen Kitt <skitt@debian.org>  Sat, 29 Aug 2020 20:47:14 +0200

rr (5.3.0-3) unstable; urgency=medium

  * Restore the i386 package, depending on sse2-support so that
    installations on platforms without the required SSE2 support will
    fail. Closes: #961710.
  * Add rr-collect-symbols manpage.

 -- Stephen Kitt <skitt@debian.org>  Sat, 30 May 2020 14:49:46 +0200
