=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Priority: optional
 Build-Depends: capnproto,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dh-python,
-               g++-multilib,
+               g++-multilib | g++-i686-linux-gnu,
                gdb,
                libcapnp-dev,
                libdisasm-dev,
@@ -23,10 +23,11 @@
 Rules-Requires-Root: no
 
 Package: rr
-Architecture: amd64
+Architecture: amd64 i386
 Depends: ${misc:Depends},
          ${python3:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         sse2-support [i386]
 Description: application execution recorder, player and debugger
  rr allows application executions to be recorded and then replayed
  with gdb as many times as desired.
@@ -36,5 +37,5 @@
  always identical from one run to another.
  .
  rr is incompatible with ptrace hardening, and currently only supports
- Intel CPUs with Nehalem or later microarchitectures. The amd64
- package supports debugging amd64 and i386 binaries.
+ Intel CPUs with Nehalem or later microarchitectures, and some Zen
+ CPUs. The amd64 package supports debugging amd64 and i386 binaries.
