## rr 5.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 4)
+set(rr_VERSION_MINOR 5)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
@@ -55,7 +55,7 @@
 set(x86ish false)
 if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
   set(supports32bit false)
-  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a")
+  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a -Wl,-dynamic-linker=/lib/aarch64-linux-gnu/atomics/ld-linux-aarch64.so.1")
 else()
   set(x86ish true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
@@ -151,7 +151,7 @@
   # try_compile won't accept LINK_FLAGS, so do this manually.
   file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
   execute_process(COMMAND ${CMAKE_C_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
-			RESULT_VARIABLE COMPILER_32BIT_RESULT)
+                  RESULT_VARIABLE COMPILER_32BIT_RESULT)
   if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
     message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation. Install the required packages or pass -Ddisable32bit=ON to cmake.")
   endif()
@@ -184,7 +184,7 @@
 
 find_program(CAPNP capnp)
 if(${CAPNP} STREQUAL "CAPNP-NOTFOUND")
-  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/mozilla/rr/wiki/Building-And-Installing#tldr")
+  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/rr-debugger/rr/wiki/Building-And-Installing#tldr")
 endif()
 
 set(REQUIRED_LIBS
@@ -306,12 +306,6 @@
 
 foreach(py_module ${REQUIRED_PYTHON_MODULES})
   execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
-			"import ${py_module}"
-			RESULT_VARIABLE module_status)
+                  "import ${py_module}"
+                  RESULT_VARIABLE module_status)
   if(module_status)
-    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
-  endif()
-endforeach(py_module)
-
-if(WILL_RUN_TESTS)
-  # Check for gdb
