=== debian/changelog ===
rr (5.5.0-1ubuntu0.1) jammy; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.5.0-1build1) jammy; urgency=medium

  * No-change rebuild against libcapnp-0.8.0

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Mar 2022 17:01:17 +0000

rr (5.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 04 Oct 2021 08:24:33 +0200
