=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: rr
-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 13),
                dh-python,
-               g++-multilib | g++-i686-linux-gnu,
+               g++-multilib,
                gdb,
                libcapnp-dev,
                libdisasm-dev,
@@ -16,7 +17,7 @@
                python3-pexpect
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: http://rr-project.org
