=== debian/rules ===
--- 
+++ 
@@ -23,15 +23,18 @@
 	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
 	mkdir -p debian/rr/usr/lib/rr
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
-	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/librrpreload* debian/rr/usr/lib/rr/
+	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/lib*.so debian/rr/usr/lib/rr/
 	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
 	chmod 644 debian/rr/usr/share/bash-completion/completions/rr
 
 override_dh_strip:
-	dh_strip -Xlibrrpreload
+	dh_strip -Xlibrr
 
 override_dh_dwz:
 	dh_dwz --no-dwz-multifile
 
 override_dh_python3:
 	dh_python3 --no-ext-rename
+
+override_dh_makeshlibs:
+	dh_makeshlibs -n
